<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0
         http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>org.sic.javabasics00</groupId>
    <artifactId>sic-mvn</artifactId>
    <version>1.0.0</version>
    <packaging>jar</packaging>

    <properties>
        <java.version>17</java.version>
        <junit-jupiter.version>5.5.2</junit-jupiter.version>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
    </properties>

    <dependencies>
        <!-- junit 5 -->
        <dependency>
            <groupId>org.junit.jupiter</groupId>
            <artifactId>junit-jupiter-engine</artifactId>
            <version>${junit-jupiter.version}</version>
            <scope>test</scope>
        </dependency>
    </dependencies>

    <build>
        <plugins>
            <!-- Need at least 2.22.0 to support JUnit 5 -->
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>3.0.0-M3</version>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.8.1</version>
                <configuration>
                    <source>17</source>
                    <target>17</target>
                </configuration>
            </plugin>
            <plugin>
                <groupId>io.github.git-commit-id</groupId>
                <artifactId>git-commit-id-maven-plugin</artifactId>
                <version>5.0.0</version>
                <executions>
                    <execution>
                        <id>get-the-git-infos</id>
                        <goals>
                            <goal>revision</goal>
                        </goals>
                        <phase>initialize</phase>
                    </execution>
                </executions>
                <configuration>
                    <generateGitPropertiesFile>true</generateGitPropertiesFile>
                    <generateGitPropertiesFilename>${project.build.outputDirectory}/git.properties</generateGitPropertiesFilename>
                    <!-- includeOnlyProperties>
                        <includeOnlyProperty>^git.build.(time|version)$</includeOnlyProperty>
                        <includeOnlyProperty>^git.commit.id.(abbrev|describe|full)$</includeOnlyProperty>
                        closest.tag.name
                    </includeOnlyProperties -->
                    <commitIdGenerationMode>full</commitIdGenerationMode>
                </configuration>
            </plugin>
            <plugin>
                <groupId>io.github.1tchy</groupId>
                <artifactId>variable-search-replace-plugin</artifactId>
                <version>1.3</version>
                <executions>
                    <execution>
                        <id>replace-git-describe</id>
                        <goals>
                            <goal>replace</goal>
                        </goals>
                        <configuration>
                            <text>${git.commit.id.describe}</text>
                            <search>^v</search>
                            <replacement></replacement>
                            <variableName>git.commit.id.describe2</variableName>
                        </configuration>
                    </execution>
                    <execution>
                        <id>replace-git-tag</id>
                        <goals>
                            <goal>replace</goal>
                        </goals>
                        <configuration>
                            <text>${git.closest.tag.name}</text>
                            <search>^v</search>
                            <replacement></replacement>
                            <variableName>git.closest.tag.name2</variableName>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-jar-plugin</artifactId>
                <configuration>
                    <archive>
                        <manifestEntries>
                            <Main-Class>org.sic.base.Version</Main-Class>
                            <Extension-Name>org.sic.base</Extension-Name>
                            <Implementation-Branch>${git.branch}</Implementation-Branch>
                            <Implementation-Commit>${git.commit.id.full}</Implementation-Commit>
                            <Implementation-Version>${git.commit.id.describe2}</Implementation-Version>
                            <Specification-Version>${git.closest.tag.name2}</Specification-Version>
                        </manifestEntries>
                    </archive>
                </configuration>
            </plugin>
        </plugins>
        <finalName>${project.artifactId}-${git.commit.id.describe2}</finalName>
    </build>

</project>

